VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Longtime-Timer"
   ClientHeight    =   4455
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5055
   LinkTopic       =   "Form1"
   ScaleHeight     =   4455
   ScaleWidth      =   5055
   StartUpPosition =   3  'Windows-Standard
   Begin VB.ListBox List1 
      Height          =   2400
      Left            =   120
      TabIndex        =   9
      Top             =   1920
      Width           =   4815
   End
   Begin VB.Frame FraTimer 
      Caption         =   "Feuere..."
      Height          =   1335
      Left            =   2520
      TabIndex        =   4
      Top             =   120
      Width           =   2415
      Begin VB.OptionButton Option3 
         Caption         =   "Andauernd"
         Height          =   255
         Left            =   120
         TabIndex        =   8
         Top             =   240
         Width           =   1215
      End
      Begin VB.TextBox TxtXTimes 
         Alignment       =   1  'Rechts
         Height          =   285
         Left            =   1080
         TabIndex        =   7
         Text            =   "10"
         Top             =   600
         Width           =   1095
      End
      Begin VB.OptionButton Option2 
         Caption         =   "x-mal:"
         Height          =   255
         Left            =   120
         TabIndex        =   6
         Top             =   600
         Width           =   855
      End
      Begin VB.OptionButton Option1 
         Caption         =   "Einmal"
         Height          =   255
         Left            =   120
         TabIndex        =   5
         Top             =   960
         Width           =   1935
      End
   End
   Begin VB.TextBox TxtSeconds 
      Alignment       =   1  'Rechts
      Height          =   285
      Left            =   120
      TabIndex        =   2
      Text            =   "123"
      Top             =   480
      Width           =   1335
   End
   Begin VB.CommandButton BtnStart 
      Caption         =   "Start"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   960
      Width           =   2295
   End
   Begin VB.Timer Timer1 
      Left            =   1920
      Top             =   120
   End
   Begin VB.Label Label2 
      Caption         =   "Interval:"
      Height          =   255
      Left            =   120
      TabIndex        =   10
      Top             =   240
      Width           =   1455
   End
   Begin VB.Label Label3 
      Caption         =   "Sekunden"
      Height          =   255
      Left            =   1560
      TabIndex        =   3
      Top             =   480
      Width           =   855
   End
   Begin VB.Label Label1 
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   1560
      Width           =   4815
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private WithEvents mTim As LongTimer
Attribute mTim.VB_VarHelpID = -1
'Das Interval eines VB.Timers lt sich maximal bis zu einem Wert von 65535 einstellen
'(das sind 65 Sekunden und 535 Millisekunden).
'Was kann man tun, wenn man einen Timer bentigt, der jedoch viel lngere Intervalle
'akzeptieren soll, mehrere Minuten, Stunden, Wochen oder gar Jahre?
'Wie kann man die bentigte Verzgerung erreichen?
'Die Antwort ist ganz simpel. Man setzt den Timer in eine Klasse die das Timerereignis
'nach der maximalen Zeitspanne abfngt, um dann seinerseits zum bentigten Zeitpunkt
'ein Event zu werfen.
'Dabei ist es leicht verschmerzbar, auf eine Millisekundenangabe zu verzeichten, da es
'bei sehr langen Zeitspannen normalerweise nicht auf die Millisekunde ankommt.
'Eine zeitliche Auflsungsgenauigkeit von Sekunden ist fr diese Zwecke normalerweise
'ausreichend.
'Auerdem kann die Hufigkeit des Timerereignisses eingestellt werden. So kann der Timer
'entweder ein Einzigesmal (FireOnce), oder eine bestimtme Anzahl (FireXTimes) oder
'andauernd (FirePermanent) feuern.

Private Sub Form_Load()
   'Ein VB.Timer-Control mit Namen Timer1 mu auf dem Formular vorhanden sein.
   Option3.Value = True
End Sub

Private Sub BtnStart_Click()
    Set mTim = New_LongTimer(Me.Timer1, GetFireKind, GetFireCount)
    If IsNumeric(TxtSeconds.Text) Then
        mTim.IntervalSec = CLng(TxtSeconds.Text)
    End If
    Label1.Caption = mTim.ToString & "   " & CStr(Time)
    List1.Clear
    mTim.Enabled = True
End Sub

Private Sub mTim_Timer()
    'dieses Ereignis kommt nicht direkt von der VB.Timer-Komponente
    'sondern von der Klasse LongTimer
    Call List1.AddItem(mTim.ToString & "   " & CStr(Time))
End Sub
 
Private Function GetFireKind() As FireKind
    If Option3.Value Then GetFireKind = FirePermanent
    If Option2.Value Then GetFireKind = FireXTimes
    If Option1.Value Then GetFireKind = FireOnce
End Function
Private Function GetFireCount() As Long
    If Option2.Value Then
        If IsNumeric(TxtXTimes.Text) Then
            GetFireCount = CLng(TxtXTimes.Text)
        End If
    End If
End Function

Private Sub Option1_Click()
    TxtXTimes.Enabled = False
End Sub
Private Sub Option2_Click()
    TxtXTimes.Enabled = True
End Sub
Private Sub Option3_Click()
    TxtXTimes.Enabled = False
End Sub
