VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "LongTimer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Public Enum FireKind
    FirePermanent
    FireXTimes
    FireOnce
End Enum
Private WithEvents mTim As VB.Timer
Attribute mTim.VB_VarHelpID = -1
'Maximal 60 Sek. das macht der VB.Timer noch gut mit:
Private Const mCMaxI    As Long = 60
Private mInterval       As Long
'speichert die Anzahl der Intervalle die bisher verstrichen sind:
Private mIntervals      As Long
'speichert den Divisionrest von mInterval Mod mMaxI:
Private mModIntMax      As Long
Private mFireKind       As FireKind
'zhlt nach oben, bis mCount
Private mXTime          As Long
'speichert wie oft der Timer bei Firekind.FireXTimes insgesamt melden soll
Private mCount          As Long

Public Event Timer()
'ein lustiger Timer,
'der soll lange Zeitspannen berbrcken knnen
'also nicht nur die maximal 65535 ms des VB Timers
'sondern noch viiiiel lnger,
'Sekunden
'Minuten
'Stunden
'Wochen
'Monate
'Jahre
'Tage
'##########
'1 Sek = 1000 ms
'1 Min = 60 Sek
'1 Std = 3600 Sek.
'1 Tag = 86400 Sek.
'1 Week = 604800 Sek.
'1 Year(365Tage) = 31536000 Sek.
'
'2147483647
'31536000
'max 68 Jahre in einem Long, das drfte frs erste reichen ;)

'
' #################### ' v  Public Procedures  v  ' #################### '
Public Sub NewC(aTim As VB.Timer, _
                Optional ByVal aFKind As FireKind = FirePermanent, _
                Optional ByVal aCount As Long)
    Set mTim = aTim
    mTim.Enabled = False
    mFireKind = aFKind
    mCount = aCount       'die Anzahl insgesamt
End Sub

'ReadOnly
Public Property Get Count() As Long
    Count = mCount
End Property
Public Property Get XTime() As Long
    XTime = mXTime
End Property

Public Property Get FireKind() As FireKind
    FireKind = mFireKind
End Property
Public Property Let FireKind(RHS As FireKind)
    mFireKind = RHS
End Property

Public Property Get Enabled() As Boolean
    Enabled = mTim.Enabled
End Property
Public Property Let Enabled(RHS As Boolean)
    mTim.Enabled = RHS
End Property

'die folgenden beiden Funktionen knnen ganz ntzlich sein, falls
'der User den Timer von Hand schalten kann, und das Programm trotzdem
'unabhngig von der Usereinstellung den Timer ein/ausschalten mu.
'Einfach den zurckgegebenen Wert in einer Variablen speichern, und den
'gespeicherten Wert mit Property Let Enabled wieder setzen.
Public Function DisableTimer() As Boolean
    DisableTimer = mTim.Enabled
    Enabled = False
End Function
Public Function EnableTimer() As Boolean
    EnableTimer = mTim.Enabled
    Enabled = True
End Function

Public Property Get IntervalSec() As Long
    IntervalSec = mInterval
End Property
Public Property Let IntervalSec(RHS As Long)
    mInterval = RHS
    mModIntMax = mInterval Mod mCMaxI
    mTim.Interval = IIf(mInterval >= mCMaxI, mCMaxI, mInterval) * 1000
End Property

Public Function ToString() As String
    Dim s As String
    s = mTim.Name & ": " & FireKindToString(mFireKind) & " "
    If mFireKind = FireXTimes Then
        s = s & ": " & CStr(mXTime) & " / " & _
                       CStr(mCount - mXTime) & " / " & _
                       CStr(mCount) & "    "
    End If
    ToString = s & Timer
End Function

' #################### ' v  Private Procedures  v  ' #################### '
Private Function FireKindToString(fk As FireKind)
    Select Case fk
    Case FireOnce:      FireKindToString = "FireOnce"
    Case FireXTimes:    FireKindToString = "FireXTimes"
    Case FirePermanent: FireKindToString = "FirePermanent"
    End Select
End Function

Private Function CheckInterval() As Boolean
    Dim diff As Long
    If mInterval <= mCMaxI Then
        CheckInterval = True
    Else
        Call IncIntervals
        diff = mInterval - mIntervals
        If diff = mModIntMax Then
            If mModIntMax = 0 Then 'Null gesondert behandeln
                CheckInterval = True
            Else
                mTim.Interval = mModIntMax * 1000
            End If
        ElseIf diff < mModIntMax Then
            CheckInterval = True
        End If
        If CheckInterval Then
            mIntervals = 0
            mTim.Interval = mCMaxI * 1000
        End If
    End If
End Function
Private Sub IncIntervals()
    mIntervals = mIntervals + mCMaxI
End Sub
Private Sub mTim_Timer()
    'hier wird das Event empfangen und falls die Zeit
    'erreicht ist, wird das Event gleich wieder weitergeworfen
    If CheckInterval Then
        Select Case mFireKind
        Case FireOnce
            mTim.Enabled = False
        Case FireXTimes
            mXTime = mXTime + 1
            If mXTime = mCount Then
                mTim.Enabled = False
            End If
        Case FirePermanent
            'nix machen
        End Select
        RaiseEvent Timer
    End If
End Sub

'Erweiterungen
'=============
'die Klasse ist leicht an eigenen Bedrfnisse anpassbar. So kann man in diese Klasse
'vieles an Funktionalitt einprogrammieren, was man schon immer von einem Timer
'erwartet hat, und vom VB.Timer schmerzlich vermisst.
'Denkbare Erweiterungen der Klasse wren:
'* Persistenz
'  ===========
'Um als Intervall mehrere Wochen oder gar Monate zu erreichen, mte da der Timer
'nicht die ganze Zeit ber laufen? Mte also das Programm und der Computer die ganze
'Zeit ber laufen? Das wre ja nicht sehr praktikabel. Es reicht im Grunde aus, wenn
'der Computer und das Timerprogramm nur kurze Zeit vorher, bevor das Timerereignis
'eintreten soll, gestartet wird. Die Lsung ist, den Timer persistent zu machen, was
'nix anderes heit, als da der Timer alle bentigten Daten auf die Festplatte speichert,
'und diese bei Programmstart von dort auch wieder einliest.
'* Termin
'  =======
'Es knnte entweder ein bestimmtes Intervall, oder aber auch ein bestimmter Termin
'eingestellt werden. Dabei liee sich einstellen, ob der Termin jede Stunde, jeden Tag,
'jede Woche, jeden Monat oder jedes Jahr wiederkehren sollte.

